#include <gtk/gtk.h>
#include <webkit2/webkit2.h>
#include <webkit2/webkit-web-extension.h>

void  window_object_cleared(WebKitScriptWorld *world,
			    WebKitWebPage     *page,
			    WebKitFrame       *frame,
			    gpointer           user_data){
  printf("window-object-cleared!!\n");
  fflush(stdout);
}

int main( int   argc,
          char *argv[] )
{
  GtkWidget *window; 
  gtk_init (&argc, &argv);
   
  window = gtk_window_new (GTK_WINDOW_TOPLEVEL);
  gtk_window_set_default_size (GTK_WINDOW(window),600,300);

  WebKitWebView *webView = WEBKIT_WEB_VIEW(webkit_web_view_new());
  gtk_container_add (GTK_CONTAINER(window), GTK_WIDGET(webView));

  webkit_web_view_load_uri(webView, "http://www.google.ca");
  WebKitScriptWorld * world = webkit_script_world_get_default ();
  g_signal_connect(world, "window-object-cleared", G_CALLBACK(window_object_cleared), NULL);

  webkit_web_view_run_javascript (webView,
				  "window.onmouseup = function(){alert(\"mouse up!\");};",
				  NULL,
				  NULL,
				  NULL);

  gtk_widget_show (GTK_WIDGET(webView));
  gtk_widget_show (window);
  gtk_main ();
  return 0;
}
